Index: /code/branches/gui/src/orxonox/gamestates/GSGUI.cc
===================================================================
--- /code/branches/gui/src/orxonox/gamestates/GSGUI.cc	(revision 2807)
+++ /code/branches/gui/src/orxonox/gamestates/GSGUI.cc	(revision 2808)
@@ -53,5 +53,5 @@
 
         // show main menu
-        guiManager_->loadScene("MainMenu");
+        //guiManager_->loadScene("MainMenu");
         guiManager_->showGUI("MainMenu", 0);
         GraphicsManager::getInstance().getViewport()->setCamera(guiManager_->getCamera());
Index: /code/branches/gui/src/orxonox/gamestates/GSStandalone.cc
===================================================================
--- /code/branches/gui/src/orxonox/gamestates/GSStandalone.cc	(revision 2807)
+++ /code/branches/gui/src/orxonox/gamestates/GSStandalone.cc	(revision 2808)
@@ -39,8 +39,4 @@
 namespace orxonox
 {
-    SetConsoleCommand(GSStandalone, showGUI, true).setAsInputCommand();
-
-    bool GSStandalone::guiShowing_s = false;
-
     GSStandalone::GSStandalone()
         : GameState<GSGraphics>("standalone")
@@ -52,8 +48,4 @@
     }
 
-    void GSStandalone::showGUI()
-    {
-        GSStandalone::guiShowing_s = true;
-    }
 
     void GSStandalone::enter()
@@ -66,4 +58,7 @@
         // not sure if necessary
         // guiManager_->loadScene("IngameMenu");
+
+        Ogre::Viewport* viewport = GraphicsManager::getInstance().getViewport();
+        guiManager_->showGUI("IngameMenu", viewport->getCamera()->getSceneManager());
     }
 
@@ -77,14 +72,10 @@
     void GSStandalone::ticked(const Clock& time)
     {
-        if (guiShowing_s)
-        {
-            Ogre::Viewport* viewport = GraphicsManager::getInstance().getViewport();
-            guiManager_->showGUI("IngameMenu", viewport->getCamera()->getSceneManager());
-        }
-        else
-        {
-            if (guiManager_)
-                guiManager_->hideGUI();
-        }
+        Ogre::Viewport* viewport = GraphicsManager::getInstance().getViewport();
+        //COUT(0) << "** " << viewport->getCamera()->getSceneManager() << std::endl;
+        //guiManager_->testFct();
+        //Ogre::Viewport* viewport = GraphicsManager::getInstance().getViewport();
+        guiManager_->showGUI("IngameMenu", viewport->getCamera()->getSceneManager());
+
         // tick CEGUI
         guiManager_->update(time);
Index: /code/branches/gui/src/orxonox/gamestates/GSStandalone.h
===================================================================
--- /code/branches/gui/src/orxonox/gamestates/GSStandalone.h	(revision 2807)
+++ /code/branches/gui/src/orxonox/gamestates/GSStandalone.h	(revision 2808)
@@ -41,5 +41,4 @@
         GSStandalone();
         ~GSStandalone();
-        static void showGUI();
 
     private:
@@ -49,5 +48,4 @@
 
         GUIManager*     guiManager_;
-        static bool     guiShowing_s;
     };
 }
Index: /code/branches/gui/src/orxonox/gui/GUIManager.cc
===================================================================
--- /code/branches/gui/src/orxonox/gui/GUIManager.cc	(revision 2807)
+++ /code/branches/gui/src/orxonox/gui/GUIManager.cc	(revision 2808)
@@ -63,5 +63,5 @@
 namespace orxonox
 {
-    SetConsoleCommandShortcut(GUIManager, showGUI_s).keybindMode(KeybindMode::OnPress);
+    SetConsoleCommandShortcut(GUIManager, toggleGUI).keybindMode(KeybindMode::OnPress);
 
     GUIManager* GUIManager::singletonRef_s = 0;
@@ -143,5 +143,5 @@
 
                 // Note: No SceneManager specified yet
-                this->guiRenderer_ = new OgreCEGUIRenderer(renderWindow_, Ogre::RENDER_QUEUE_MAIN, true, 3000);
+                this->guiRenderer_ = new OgreCEGUIRenderer(renderWindow_, Ogre::RENDER_QUEUE_OVERLAY, true, 3000);
                 this->resourceProvider_ = guiRenderer_->createResourceProvider();
                 this->resourceProvider_->setDefaultResourceGroup("GUI");
@@ -172,5 +172,5 @@
 
                 // load the background scene
-                //loadScenes();
+                loadScenes();
                 //CEGUI::KeyEventArgs e;
                 //e.codepoint
@@ -204,5 +204,5 @@
                 tolua_Orxonox_open(this->scriptModule_->getLuaState());
                 */
-                this->scriptModule_->executeScriptFile("ingameGUI.lua", "GUI");
+                this->scriptModule_->executeScriptFile("loadGUI.lua", "GUI");
             }
             catch (CEGUI::Exception& ex)
@@ -261,4 +261,10 @@
     }
 
+    void GUIManager::toggleGUI()
+    {
+        //COUT(0) << "********* TOGGLE TOGGLE **********" << std::endl;
+        getInstance().scriptModule_->executeScriptGlobal("toggleGUI");
+    }
+
     void GUIManager::showGUI(const std::string& name, Ogre::SceneManager* sceneManager)// bool showBackground)
     {
@@ -271,5 +277,5 @@
             try
             {
-//                COUT (0) << "************* sceneManager: " << sceneManager << std::endl;
+		// COUT (0) << "************* sceneManager: " << sceneManager << std::endl;
                 if (!sceneManager)
                 {
@@ -286,4 +292,5 @@
                     //this->viewport_->setClearEveryFrame(false);
                     this->guiRenderer_->setTargetSceneManager(sceneManager);
+                    currentSceneManager_ = sceneManager;
                     //this->viewport_->setCamera(this->emptyCamera_);
 
@@ -311,4 +318,15 @@
             COUT(2) << "Warning: GUI Manager not yet initialised, cannot load a GUI" << std::endl;
         }
+    }
+
+    void GUIManager::testFct()
+    {
+        //COUT(0) << "**** " << currentSceneManager_ << std::endl;
+        this->showGUI("IngameMenu", currentSceneManager_);
+    }
+
+    void GUIManager::testOutput(const std::string& str)
+    {
+        COUT(0) << "***" << str << "***" << std::endl;
     }
 
Index: /code/branches/gui/src/orxonox/gui/GUIManager.h
===================================================================
--- /code/branches/gui/src/orxonox/gui/GUIManager.h	(revision 2807)
+++ /code/branches/gui/src/orxonox/gui/GUIManager.h	(revision 2808)
@@ -79,4 +79,7 @@
         void showGUI(const std::string& name, Ogre::SceneManager* sceneManager);// bool showBackground); // tolua_export
         void hideGUI(); // tolua_export
+        void testOutput(const std::string& str); // tolua_export
+
+        static void toggleGUI();
 
         Ogre::Camera* getCamera() { return this->backgroundCamera_; }
@@ -86,4 +89,7 @@
             getInstance().showGUI(name, sceneManager);
         }
+
+        // please remove
+        void testFct();
 
         static GUIManager& getInstance()    { assert(singletonRef_s); return *singletonRef_s; } // tolua_export
@@ -128,4 +134,5 @@
         CEGUI::Imageset*          backgroundImage_;
         lua_State*                luaState_;
+        Ogre::SceneManager*         currentSceneManager_;
 
         State state_;